### Method

# Gck Session encrypt

#### Declaration [src]

    guchar*
    gck_session_encrypt (
      GckSession* self,
      GckObject* key,
      gulong mech_type,
      const guchar* input,
      gsize n_input,
      gsize* n_result,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Encrypt data in a mechanism specific manner. This call may block for an indefinite period.

#### Parameters

`key`

  Type: `GckObject`

  The key to encrypt with.

  The data is owned by the caller of the method.

`mech_type`

  Type: `gulong`

  The mechanism type to use for encryption.

`input`

  Type: An array of `guchar`

  The data to encrypt.

  The length of the array is specified in the `n_input` argument.
  The data is owned by the caller of the method.

`n_input`

  Type: `gsize`

  The length of the data to encrypt.

`n_result`

  Type: `gsize*`

  Location to store the length of the result data.

  The argument will be set by the function.

`cancellable`

  Type: `GCancellable`

  Optional cancellation object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: An array of `guchar`

The data that was encrypted, or `NULL` if an error occured.

The length of the array is in the `n_result` argument.
The caller of the method takes ownership of the returned data, and is responsible for freeing it.